var index =
[
    [ "Introduction", "index.html#intro_sec", [
      [ "Example Applications", "index.html#examples", null ]
    ] ],
    [ "Installing and Executing MAiNGO", "install.html", [
      [ "Obtaining MAiNGO", "install.html#get_maingo", [
        [ "Updating MAiNGO", "install.html#update_maingo", null ]
      ] ],
      [ "Required Software", "install.html#req_software", null ],
      [ "Generating and Compiling the Project", "install.html#cmake", [
        [ "Windows", "install.html#cmake_win", null ],
        [ "Linux and Mac OS", "install.html#cmake_linux_os", null ],
        [ "CMake Variables", "install.html#cmake_variables", null ],
        [ "Executing MAiNGO", "install.html#executing_maingo", null ]
      ] ]
    ] ],
    [ "Modeling in MAiNGO", "writing_problem.html", [
      [ "Modeling with ALE", "writing_problem.html#modeling_ALE", [
        [ "File Structure", "writing_problem.html#ALE_general", null ],
        [ "Parameter, Variable, and Expression Symbols", "writing_problem.html#ALE_definitions", [
          [ "Parameter Symbol Definitions", "writing_problem.html#parameter_definitions", null ],
          [ "Variable Symbol Definitions", "writing_problem.html#variable_definitions", null ],
          [ "Expression Symbol Definitions", "writing_problem.html#expression_definitions", null ]
        ] ],
        [ "Further Section Headings", "writing_problem.html#further_sections", [
          [ "Objective section", "writing_problem.html#objective_section", null ],
          [ "Outputs Ssection", "writing_problem.html#outputs_section", null ],
          [ "Constraints Section", "writing_problem.html#constraint_section", null ],
          [ "Relaxation-only Constraints Section", "writing_problem.html#relaxation_section", null ],
          [ "Squashing Constraint Section", "writing_problem.html#squashing_section", null ]
        ] ],
        [ "Example Input File", "writing_problem.html#example_input", null ],
        [ "Expressions", "writing_problem.html#ALE_expressions", [
          [ "Scalar Real Expressions", "writing_problem.html#real_expressions", null ],
          [ "Scalar Index Expressions", "writing_problem.html#index_expressions", null ],
          [ "Scalar Boolean Expressions", "writing_problem.html#boolean_expressions", null ],
          [ "Set Expressions", "writing_problem.html#set_expressions", null ]
        ] ]
      ] ],
      [ "Modeling via C++", "writing_problem.html#modeling_cpp", [
        [ "Advanced Modeling", "writing_problem.html#advanced_modeling", null ]
      ] ],
      [ "Parsing GAMS Files", "writing_problem.html#parsing_gams", null ]
    ] ],
    [ "How does MAiNGO work?", "algorithm.html", [
      [ "Lower Bounding Solvers", "algorithm.html#LBS", null ],
      [ "Upper Bounding Solvers", "algorithm.html#UBS", null ]
    ] ],
    [ "MAiNGO - Parallel Version", "parallel_version.html", null ],
    [ "Special Uses of MAiNGO", "special_uses.html", [
      [ "Using MAiNGO as a multi-start local solver:", "special_uses.html#maingo_multistart", null ],
      [ "Using MAiNGO as a pure B&B Solver:", "special_uses.html#maingo_pure_bab", null ],
      [ "Using MAiNGO to check feasibility of a single point:", "special_uses.html#maingo_feasibility_of_single_point", null ],
      [ "Using MAiNGO to solve Bi-objective Problems:", "special_uses.html#maingo_epsilon_constraint", null ],
      [ "Using MAiNGO to write Files in other Modeling Languages:", "special_uses.html#maingo_write_files_to_other_language", null ]
    ] ],
    [ "Using MAiNGO in Other Software", "maingo_in_your_software.html", [
      [ "Using MAiNGO as a Standalone Solver", "maingo_in_your_software.html#standalone", null ],
      [ "Embedding MAiNGO in your Application", "maingo_in_your_software.html#embedded", null ],
      [ "Extending MAiNGO", "maingo_in_your_software.html#extensions", null ]
    ] ],
    [ "MAiNGO Settings", "maingo_settings.html", null ],
    [ "What can go wrong?", "faq.html", [
      [ "After starting the MAiNGO executable nothing happens", "faq.html#faq1", null ],
      [ "MAiNGO reports a Problem to be infeasible although you expect it to be feasible", "faq.html#faq2", null ],
      [ "MAiNGO reports a domain violation, e.g., division by 0", "faq.html#faq3", [
        [ "MAiNGO terminates with a MC++ error saying something about alpha1 and alpha2", "faq.html#faq5", null ],
        [ "MAiNGO finds feasible solutions early on, but the LBD takes forever to converge", "faq.html#faq6", null ],
        [ "MAiNGO runs forever without finding a feasible point although LBD seems to be converged already", "faq.html#faq7", null ]
      ] ]
    ] ],
    [ "Where can I read more?", "bib.html", [
      [ "Relaxations", "bib.html#readRelaxations", null ],
      [ "Branch-and-Bound", "bib.html#readBaB", null ],
      [ "Range Reduction", "bib.html#readRR", null ],
      [ "Uses of MAiNGO", "bib.html#readUses", null ]
    ] ]
];