# Example Problems

## About

This folder contains example problems for MAiNGO. 
If you are new to MAiNGO, we recommend to look at the following documents in this order:
* `doc/html/index.html`: This is the manual for MAiNGO. It includes information on how to install and execute MAiNGO.
* `01_BasicExample`: This folder contains the most basic example for solving problems with MAiNGO.

Most examples are available in two forms: once for the C++ API of MAiNGO, and once for the text-based input using the ALE library.

To solve a problem via the text-based ALE input, you need to make sure that the CMake variable `MAiNGO_build_parser` is set to `true`.
After compiling MAiNGO, you obtain an executable called `MAiNGO` which contains a parser for reading ALE input.
By default, MAiNGO searches for a problem file called `problem.txt` in the current working directory from which you executed MAiNGO.
You can specify a differen problem file name (including an absolute or relative path) as a command line argument.
As an optional second command line argument, you can specify the file name (and path) of a settings file. If no settings file is specified, MAiNGO looks for a file called `MAiNGOSettings.txt`.
An example for a settings file can be found in this directory (`examples`).

To solve a problem via the C++ API of MAiNGO, you need to make sure that the CMake variable `MAiNGO_build_standalone` is set to `true`.
The problem is implemented by specializing the abstract `MAiNGOModel` class. In the examples, this is accomplished in a dedicated header file (e.g., `01_BasicExample/problem.h`).
You need to include the header file with your problem definition in the `mainCppApi.cpp` file in this directory and then compile MAiNGO. This will produce an executable called `MAiNGOcpp`.
When running this executable, the problem will be solved. Here, the only (optional) command line argument is the settings file name.